# Class BasicControlPalette

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
jam.controlpalettes.BasicControlPalette

All Implemented Interfaces:
  `ControlPalette, ImageObserver, MenuContainer, Serializable, Accessible`

public class BasicControlPalette extends JPanel implements ControlPalette

Version:
  $Id: BasicControlPalette.java 948 2008-10-02 00:19:47Z rambaut $
Author:
  Andrew Rambaut
See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static enum`
`BasicControlPalette.DisplayMode`

### Nested classes/interfaces inherited from class JComponent

`JComponent.AccessibleJComponent`

### Nested classes/interfaces inherited from class Component

`Component.BaselineResizeBehavior`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`DEFAULT_OPENING_SPEED`

### Fields inherited from class JComponent

`TOOL_TIP_TEXT_KEY, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class Component

`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`BasicControlPalette(int preferredWidth)`
`BasicControlPalette(int preferredWidth, BasicControlPalette.DisplayMode displayMode)`
`BasicControlPalette(int preferredWidth, BasicControlPalette.DisplayMode displayMode, int openingSpeed)`

## Method Summary

Modifier and Type
Method
Description
`void`
`addController(int position, Controller controller)`
`void`
`addController(Controller controller)`
install a Controller into the palette
`void`
`addControlPaletteListener(ControlPaletteListener listener)`
Add a listener to this palette
`void`
`fireControlsChanged()`
tell listeners that the palette has changed
`int`
`getControllerCount()`
`Dimension`
`getMaximumSize()`
`Dimension`
`getMinimumSize()`
`JPanel`
`getPanel()`
get the panel that encloses the control palette
`Dimension`
`getPreferredSize()`
`void`
`getSettings(Map<String,Object> settings)`
Gather up all the settings from all the controls in the palette.
`void`
`initialize()`
Initialize all controllers when a new document is created.
`void`
`layoutControls()`
`void`
`removeController(Controller controller)`
`void`
`removeControlPaletteListener(ControlPaletteListener listener)`
Remove a listener fromm this palette
`void`
`setPreferredWidth(int preferredWidth)`
Set the preferred width of the control panel
`void`
`setSettings(Map<String,Object> settings)`
Distribute all the settings to all the controls in the palette.

### Methods inherited from class JPanel

`getAccessibleContext, getUI, getUIClassID, setUI, updateUI`

### Methods inherited from class JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getNextFocusableComponent, getPopupLocation, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintImmediately, paintImmediately, print, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class Container

`add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate`

### Methods inherited from class Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, createImage, createImage, createVolatileImage, createVolatileImage, dispatchEvent, enable, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### DEFAULT_OPENING_SPEED

public static final int DEFAULT_OPENING_SPEED

See Also:
  - Constant Field Values

## Constructor Details

### BasicControlPalette

public BasicControlPalette(int preferredWidth)

### BasicControlPalette

public BasicControlPalette(int preferredWidth, BasicControlPalette.DisplayMode displayMode)

### BasicControlPalette

public BasicControlPalette(int preferredWidth, BasicControlPalette.DisplayMode displayMode, int openingSpeed)

## Method Details

### getPreferredSize

public Dimension getPreferredSize()

Overrides:
  `getPreferredSize` in class `JComponent`

### getMaximumSize

public Dimension getMaximumSize()

Overrides:
  `getMaximumSize` in class `JComponent`

### getMinimumSize

public Dimension getMinimumSize()

Overrides:
  `getMinimumSize` in class `JComponent`

### getPanel

public JPanel getPanel()
Description copied from interface: `ControlPalette`
get the panel that encloses the control palette

Specified by:
  `getPanel` in interface `ControlPalette`
Returns:
  the panel

### addController

public void addController(Controller controller)
Description copied from interface: `ControlPalette`
install a Controller into the palette

Specified by:
  `addController` in interface `ControlPalette`
Parameters:
  `controller` -

### addController

public void addController(int position, Controller controller)

### removeController

public void removeController(Controller controller)

### getControllerCount

public int getControllerCount()

### fireControlsChanged

public void fireControlsChanged()
Description copied from interface: `ControlPalette`
tell listeners that the palette has changed

Specified by:
  `fireControlsChanged` in interface `ControlPalette`

### addControlPaletteListener

public void addControlPaletteListener(ControlPaletteListener listener)
Description copied from interface: `ControlPalette`
Add a listener to this palette

Specified by:
  `addControlPaletteListener` in interface `ControlPalette`
Parameters:
  `listener` -

### removeControlPaletteListener

public void removeControlPaletteListener(ControlPaletteListener listener)
Description copied from interface: `ControlPalette`
Remove a listener fromm this palette

Specified by:
  `removeControlPaletteListener` in interface `ControlPalette`
Parameters:
  `listener` -

### layoutControls

public void layoutControls()

### initialize

public void initialize()
Description copied from interface: `ControlPalette`
Initialize all controllers when a new document is created. At this point, settings can be adjusted to match the contents of the document.

Specified by:
  `initialize` in interface `ControlPalette`

### getSettings

public void getSettings(Map<String,Object> settings)
Description copied from interface: `ControlPalette`
Gather up all the settings from all the controls in the palette. This would usually called before saving them with the document that the palette controls.

Specified by:
  `getSettings` in interface `ControlPalette`
Parameters:
  `settings` -

### setSettings

public void setSettings(Map<String,Object> settings)
Description copied from interface: `ControlPalette`
Distribute all the settings to all the controls in the palette. This would usually called after loading the document that the palette controls.

Specified by:
  `setSettings` in interface `ControlPalette`
Parameters:
  `settings` -

### setPreferredWidth

public void setPreferredWidth(int preferredWidth)
Description copied from interface: `ControlPalette`
Set the preferred width of the control panel

Specified by:
  `setPreferredWidth` in interface `ControlPalette`
Parameters:
  `preferredWidth` -